﻿//This C# code file was released under the Ms-PL license
//http://www.opensource.org/licenses/ms-pl.html
//This script was originally intended for use with Microsoft Dynamics AX
//and maintained and distributed as a project on CodePlex
//http://dynamicsaxadmin.codeplex.com

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Activities;
using Microsoft.TeamFoundation.Build.Client;
using Microsoft.TeamFoundation.Build.Workflow.Activities;

namespace CodeCrib.AX.TFS
{
    [BuildActivity(HostEnvironmentOption.Agent)]
    public class RestoreDb : CodeActivity
    {
        public InArgument<string> ServerName { get; set; }
        public InArgument<string> DatabaseName { get; set; }
        public InArgument<string> BackupFilePath { get; set; }

        protected override void Execute(CodeActivityContext context)
        {
            string serverName = ServerName.Get(context);
            string databaseName = DatabaseName.Get(context);
            string backupFilePath = BackupFilePath.Get(context);

            context.TrackBuildMessage(String.Format("Restoring database {0} on server {1} from file {2}", databaseName, serverName, backupFilePath));

            Sql.DbManagement.RestoreDbFromFile(serverName, databaseName, backupFilePath);

            context.TrackBuildMessage("Database restore complete");
        }
    }
}
